<?php
require_once 'WebSearch.php';
require_once 'WebResult.php';
require_once 'WebResultSet.php';

/**
 * GoogleNX
 */
class GoogleSearch extends WebSearch
{
	/**
	 * Googlȅꍇ̃LbVPrefix
	 */
	protected $cachePrefix = "google";

	/**
	 * Google
	 */
	protected $name = "Google";

	/**
	 * Google
	 */
	protected function searchCore($query, $offset, $count)
	{
		 // ۂGoogleĂ܂
		$url ='http://www.google.co.jp/search?';
		$url.='q='.urlencode($query);
		$url.='&num=' . $count . 'hl=ja&lr=lang_ja&ie=utf-8&oe=utf-8';
		if($offset) {
			$url .= '&start='.$offset;
		}

		// DOMDocument
		$html = file_get_contents($url);

		/**
		 * Parse the HTML source.
		 */
		require_once('./HTMLParser.class.php');
		$parser = new HTMLParser;
		$parser->setRuleFile('./xhtml1-transitional_dtd.inc.php');
		$parser->setRoot('html', array('lang' => 'ja'));
		$parser->setGenericParent('body');

		$parser->parse($html);
		return $parser->dump();
	}
	
	/**
	 * ʂ𐮌`ĕԂ
	 */
	protected function getResult($data)
	{
		// DOMDocument𐶐
		$doc = new DOMdocument("1.0","UTF-8");

		// Googleʎ擾(NGɂ͑)Bhtmlǂ܂
		$doc->loadHTML($data);

		// DOMXPathCX^X𐶐DOMDocument֘AÂ
		$xpath = new DOMXPath($doc);

		// ʐ
		$webResultSet = new WebResultSet();
		// XPath]
		// 擾
		$entries = $xpath->query("//table[@bgcolor='#e5ecf9']/tr/td/font[@size='-1']/b[3]");
		$count = str_replace(',','',$entries->item(0)->nodeValue);
		$webResultSet->count = (int)($count);
		
		// 
		$entries = $xpath->query("//div[@class='g']");

		foreach($entries as $nodelist) {
			// Title
			$titlepath = $xpath->query("h2[@class='r']/a[@class='l']", $nodelist);
			$title = $titlepath->item(0)->nodeValue;
			
			// URL
			$urlpath = $xpath->query("h2[@class='r']/a[@class='l']/@href", $nodelist);
			$url = $urlpath->item(0)->nodeValue;
			$webResult = new WebResult($title, $url);
			
			// Tv
			$descpath = $xpath->query("table//td[@class='j' or @class='j hc']/font[@size='-1']", $nodelist);
			$description = $descpath->item(0)->nodeValue;
			$webResult->description = $description;

			// GooglẽLbVURL
			if($descpath->length) {
				$cachepath = $xpath->query("a[@class='fl']/@href", $descpath->item(0));
				if($cachepath->length) {
					$cacheUrl = $cachepath->item(0)->nodeValue;
					$webResult->cacheUrl = $cacheUrl;
				}
			}

			// ʂ[
			array_push($webResultSet->result, $webResult);
		}

		return $webResultSet;
	}
}
?>
