<?php
require_once 'WebSearch.php';
require_once 'WebResult.php';
require_once 'WebResultSet.php';

/**
 * LiveSearchNX
 */
class LiveSearch extends WebSearch
{
	/**
	 * Live Search̃LbVPrefix
	 */
	protected $cachePrefix = "live";

	/**
	 * Live Search
	 */
	protected $name = "Live Search";

	/**
	 * Live SearchB
	 */
	protected function searchCore($query, $offset, $count)
	{
		$tns = 'http://schemas.microsoft.com/MSNSearch/2005/09/fex'; 
		$op = array('type_ns' => 'tns',
			'type_url' => $tns);
		$client = new SoapClient('http://soap.search.msn.com/webservices.asmx?wsdl', $op);
		
		$sourceRequest = array(
			'Source' => 'Web',
			'Offset' => $offset,
			'Count' => $count,
			'ResultFields' => 'Title Url Description CacheUrl');
		$requests = array( 'SourceRequest' => $sourceRequest );
		$searchRequest = array(
			'AppID' => 'yourAppID',
			'Query' => $query,
			'SafeSearch' => 'Moderate',
			'Flags' => 'None',
			'CultureInfo' => 'ja-JP',
			'Requests' => $requests );
		$search = array('Request' => $searchRequest);

		$response = $client->Search($search);
//		print_r($response);

		return $response;
	}
	
	/**
	 * LbVɕۑ
	 */
	protected function cacheData()
	{
		$this->cache->save(json_encode($this->data), $this->cacheKey);
	}
	
	/**
	 * ʂ𐮌`ĕԂ
	 */
	protected function getResult($data)
	{
		$response = NULL;
		if(is_string($data)) {
			$response = json_decode($data);
		}
		else {
			$response = $data;
		}
		
		//var_dump($response);
		$results = $response->Response->Responses->SourceResponse->Results;
		
		$webResultSet = new WebResultSet();
		foreach ($results->Result as $result) {
			$webResult = new WebResult($result->Title, $result->Url);
			$webResult->cacheUrl = $result->CacheUrl;
			$webResult->description = $result->Description;
			
			array_push($webResultSet->result, $webResult);
		} 
		
		$webResultSet->count = $response->Response->Responses->SourceResponse->Total;
		
		return $webResultSet;
	}
}
?>
