<?php
require_once 'IWebSearch.php';
require_once 'Cache/Lite.php';

/**
 * 検索を行なうクラス
 */
class WebSearch implements IWebSearch {
	/**
	 * キャッシュを使用するかどうか。
	 */
	protected $useCache = true;
	/**
	 * キャッシュを使用するかどうかを設定する。
	 */
	public function setUseCache($flag) {
		$this->useCache = $flag;
	}

	/**
	 * キャッシュ用Prefix
	 */
	protected $cachePrefix = "";
	/**
	 * キャッシュ用Prefixを設定する。
	 */
	public function setCachePrefix($prefix) {
		$this->cachePrefix = $prefix;
	}
	public function getCachePrefix() {
		return $this->cachePrefix;
	}
	
	/**
	 * 検索エンジン名
	 */
	protected $name;
	/**
	 * 検索エンジン名
	 */
	public function getName()
	{
		return $this->name;
	}
	
	// キャッシュキー
	protected $cacheKey;
	
	// キャッシュオブジェクト
	protected $cache;
	
	// キャッシュされたデータ
	protected $data;
	
	/**
	 * 検索を行なう。
	 */
	public function search($query, $offset, $count) {
		
		// キャッシュを使用するかどうか
		if($this->useCache) {
			// キャッシュの設定
			$options = array(
				'cacheDir' => '/home/s-koichi/tmp/cache/',
				'lifeTime' => 600
			);

			// キャッシュオブジェクト生成
			$this->cache = new Cache_Lite($options);
			if(!$this->cache) {
				print ("キャッシュが生成できていない\n");
				return null;
			}
			
			// キャッシュ用のキーを生成
			$keyword = urlencode($query);
			$this->cacheKey = $keyword . "_" . get_class($this) . "_" . $offset . "_" . $this->cachePrefix;
			$this->data = $this->cache->get($this->cacheKey);
			//var_dump($this->data);
		}
		
		if(!$this->data) {
			// キャッシュされてなかったら、検索する。
			$this->data = $this->searchCore($query, $offset, $count);
			
			// キャッシュを行なう場合は、キャッシュに結果を収納する。
			if($this->useCache && $this->cache) {
				$this->cacheData();
			}
		}
		
		// 検索結果を整形して返す。
		return $this->getResult($this->data);
	}
	
	/**
	 * 検索処理
	 */
	protected function searchCore($query, $offset, $count)
	{
	}
	
	/**
	 * 検索結果をキャッシュに設定する。
	 */
	protected function cacheData()
	{
		$this->cache->save($this->data, $this->cacheKey);
	}
	
	/**
	 * 検索結果を整形して返す
	 */ 
	protected function getResult($data)
	{
	}
}
?>
