<?php
/**
 * Google, Yahoo, Live Searchを検索するクラス
 *
 */
class mixedSearch
{
	public $offset = 0;
	public $num = 10;

	private $googleSearch;
	private $liveSearch;
	private $yahooSearch;

	private $query = "";
	
	private $htmls = array("","","");
	protected $resultHtml = "";

	/**
	 * コンストラクタ
	 */
	function __construct()
	{
		require_once 'WebSearch/LiveSearch.php';
		require_once 'WebSearch/YahooSearch.php';
		require_once 'WebSearch/GoogleSearch.php';

		$this->googleSearch = new GoogleSearch();
		
		$this->yahooSearch = new YahooSearch();
		
		$this->liveSearch = new LiveSearch();
	}
	
	/**
	 * Google, Yahoo, Live Searchをまとめて検索
	 */
	public function search($query)
	{
		$this->query = $query;

		for($i = 0;$i < 5;$i++) {
			$result = array();
			 
			array_push($result, $this->googleSearch->search($this->query, $this->offset, $this->num));
			array_push($result, $this->yahooSearch->search($this->query, $this->offset, $this->num));
			array_push($result, $this->liveSearch->search($this->query, $this->offset, $this->num));
			
			$this->makeResultHTML($result);
			
			$this->offset += $this->num;
		}
	}
	
	/**
	 * 結果をHTMLで返します
	 */
	public function getResult()
	{
		$html = '<div class="result">' . "\n";

		$i = 0;
		foreach($this->htmls as $res) {
			$html .= '<div id="result' . $i . '">';
			$html .= '<h2>';
			if($i == 0) {
				$html .= $this->googleSearch->getName();
			}
			else if($i == 1) {
				$html .= $this->yahooSearch->getName();
			}
			else if($i == 2) {
				$html .= $this->liveSearch->getName();
			}
			$html .= "</h2>\n";
			$html .= "<ul>\n";

			$html .= $res;
			
			$html .= "</ul>\n";
			$html .= "</div>\n";
			$i++;
		}
		$this->resultHTML = $html;

		return $this->resultHTML;
	}
	
	/**
	 * 検索結果からHTMLを作成します
	 */
	private function makeResultHTML($results)
	{
		$i = 0;
		foreach($results as $result) {
			$html = "";
			foreach($result->result as $res) {
				$html .= "\t". '<li style="border: 1px solid #ffffff;">' . "\n";
				$html .= "\t\t" . '<div class="result_title">';
				$html .= '<a href="' . $res->url . '">';
				$html .= $res->title . "</a></div>\n";
				
				$html .= "\t\t" . '<div class="result_summary">';
				$html .= moji_cut($res->description, 120) . "</div>\n";
				
				$html .= "\t\t". '<div class="result_url">';
				$html .= moji_cut($res->url, 50) . "</div>\n";
				
				$html .= "\t</li>\n";
			}
			
			$this->htmls[$i] .= $html;
			$i++;
		}
	}
}

function moji_cut($str, $maxlen){
    //末尾の空白＆改行コード除去
    $new_str=trim($str);
    //エンティティ変換
    $new_str = htmlspecialchars($new_str);
    //指定文字数でカットし、省略マークを挿入
    if(strlen($new_str) > $maxlen){
        $new_str=mb_substr($new_str, 0, $maxlen);
        $new_str.="...";
    }
    return $new_str;
}

?>
